Main (Java SE 26 & JDK 26)
Description: declaration: module: jdk.compiler, package: com.sun.tools.javac, class: Main
Keywords: com.sun.tools.javac.Main class

# Class Main

java.lang.Object
com.sun.tools.javac.Main

public class Main extends Object
A legacy programmatic interface for the Java Programming Language compiler, javac. See the `jdk.compiler` module for details on replacement APIs.

Since:
  1.5

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Main()`
  Deprecated, for removal: This API element is subject to removal in a future version.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static int`
  `compile(String[] args)`
  Programmatic interface to the Java Programming Language compiler, javac.
  `static int`
  `compile(String[] args, PrintWriter out)`
  Programmatic interface to the Java Programming Language compiler, javac.
  `static void`
  `main(String[] args)`
  Main entry point for the launcher.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### Main

    @Deprecated(since="16", forRemoval=true) public Main()
    Deprecated, for removal: This API element is subject to removal in a future version.
    Do not call.

- ## Method Details

  - ### main

    public static void main(String[] args) throws Exception
    Main entry point for the launcher. Note: This method calls System.exit.
    Parameters:
      `args` - command line arguments
    Throws:
      `Exception` - only if an uncaught internal exception occurs; just retained for historical compatibility

  - ### compile

    public static int compile(String[] args)
    Programmatic interface to the Java Programming Language compiler, javac.
    Parameters:
      `args` - The command line arguments that would normally be passed to the javac program as described in the man page.
    Returns:
      an integer equivalent to the exit value from invoking javac, see the man page for details.

  - ### compile

    public static int compile(String[] args, PrintWriter out)
    Programmatic interface to the Java Programming Language compiler, javac.
    Parameters:
      `args` - The command line arguments that would normally be passed to the javac program as described in the man page.
      `out` - PrintWriter to which the compiler's diagnostic output is directed.
    Returns:
      an integer equivalent to the exit value from invoking javac, see the man page for details.